/*
    Living Realms is a primate evolution simulator.
    Copyright (C) 2011  Sterling Pickens

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Random.h"

#ifndef SIMPLE_LRAND
uint32_t lrand(uint64_t *s){
	// initial value of s must be 2 or higher
	uint64_t hi = *(uint64_t *)s / 41943011;
	uint64_t lo = *(uint64_t *)s % 41943011;
	*(uint64_t *)s = *(uint64_t *)s * lo - 2147483647 * hi;
	return (*(uint64_t *)s & 0xFFFFFFFF00000000) >> 32;
}
#else
uint32_t lrand(uint64_t *s){
	return (*(uint64_t *)s = *(uint64_t *)s * 41943011 - 2147483647) >> 32;
}
#endif